# Permission to use, copy, modify, and distribute this software for
# any purpose and without fee is hereby granted.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------

    require('extensions.rb')

    module Fishelzon  # Proprietary TopLevel Namespace: No Tresspassing!

      module GcodeImporterModule  # Namespace for THIS plugin

        # Create an entry in the Extension list that loads
        #  a script called: "Fishelzon\GcodeImporter_VerX.X.X.rb"
        @@lastVer = Dir.entries(File.dirname(__FILE__) + "/Fishelzon")
        @@lastVer = @@lastVer.delete_if {|item| not item[/GcodeImporter/] } 
        @@lastVer = "Fishelzon/" + @@lastVer.sort[-1]

        @@plugin = SketchupExtension.new( "Fishelzon's Gcode Importer", @@lastVer )
       
        @@plugin.creator     = 'Fishelzon David'
        @@plugin.copyright   = "(c)2013 by Fishelzon David"
        @@plugin.version     = @@lastVer.split("Ver")[1].chomp('.rb')
        @@plugin.description = "This G code Importer allows importing a 3D printers G-Code to the SketchUp 3D modeling environment."
       
        unless @@plugin.class.method_defined?(:path)
          #
          # Define a singleton method for @@plugin to access the @path attribute.
          # (... because the API did not do it in extensions.rb !!)
          #
          def @@plugin.path()
            instance_variable_get(:@path)
          end
        end # unless
       
        # Create local path and filename constants:
        #
        PATH          = @@plugin.path()
        LOADER_SUFFIX = '_loader'
        LOADER        = File.basename(PATH)
        RBSFILE       = LOADER.split("_")[0] << '.rbs'

        # RELDIR is relative to Plugins dir, OR the dir from
        # the $LOAD_PATH array that require used to find it.
        RELDIR        = File.dirname(PATH)

        # search the load paths for a valid RELDIR
        ROOT          = $LOAD_PATH.find(false) do |abspath|
          Kernel.test(?d, File.join(abspath,RELDIR) )
        end
        if ROOT
          ABSDIR = File.join( ROOT, RELDIR )
        else
          # assume the target dir is directly below, the dir that THIS file is in.
          ABSDIR = File.join( File.dirname(__FILE__), RELDIR )
        end
       
        # Register this extension with the Sketchup::ExtensionManager
        Sketchup.register_extension( @@plugin, true )

      end # module Fishelzon::GcodeImporter
    
    end # module Fishelzon
